include <../doblo-factory.scad>;
include <../lib/doblo-params-repl.scad>;

//============ Bloc du bas (desoxyribose) ============
/*
difference(){
    union(){
        cyl_block(-1,0,-3,2, height = FULL * 1.5, nibbles_on_off=false);
        nibbles(0,0, 6, 3, 2);
        block(0,0, 3, 3, 2,height=HALF);
        block(0,0, -3, 4, 2, height=FULL);
        cyl_block(3,0,-3,2, height = FULL, nibbles_on_off=false);
        translate ([31.6,-7.9,0]) cylinder(15,4,3);
    }
    translate ([12,-7.9,-10]) cylinder(r=4, h=40);
}

// ============ bloc du haut (phosphate) ============

difference(){
    difference() {
       union()
        {
            difference(){
                cyl_block(-1,0,6,2, height = FULL * 1.5, nibbles_on_off=false);
                block(0,0, 5, 2, 2,height=FULL * 2);
            }
            doblo(0,0, 6, 3, 2, height=HALF, nibbles_on_off=false);
            block(0,0, 9, 4, 2, height=FULL);
            cyl_block(3,0,9,2, height = FULL, nibbles_on_off=false);
        }
        translate ([31.6,-7.9,0]) cylinder(15,4,3);
    }
    translate ([12,-7.9,-10]) cylinder(r=4, h=40);
}


// ============ base courtes (pyrimidines) ============

// ------ 2 liaisons H (Thymine) ------

difference() {
    difference() {
        union(){
            cyl_block(3,0,3.1,2, height = FULL*0.8, nibbles_on_off=false);
            difference(){
                difference(){
                block(4,-1,3.1,4,4,height = FULL*0.8);
                translate([0,-8,0]) rotate ([0,0,15]) cube([70,20,30]);
            }
            translate([0,-28.5,0]) rotate ([0,0,-15]) cube([70,20,30]);
            }
        }   
        union(){
            translate([55,0,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
            translate([55,-15.8,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
        }
    }
    translate ([31.6,-7.9,0]) cylinder(15,4,3);
}

// ------ 3 liaisons H (Cytosine) ------

 difference() {
   difference() {
        union(){
            cyl_block(3,0,3.1,2, height = FULL*0.8, nibbles_on_off=false);
            difference(){
                difference(){
                block(4,-1,3.1,4,4,height = FULL*0.8);
                translate([0,-8,0]) rotate ([0,0,15]) cube([70,20,30]);
            }
            translate([0,-28.5,0]) rotate ([0,0,-15]) cube([70,20,30]);
            }
        }   
        union(){
            translate([55,2,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
            translate([55,-7.9,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
            translate([55,-17.8,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
        }
    }
    translate ([31.6,-7.9,0]) cylinder(15,4,3);
}
// ============ bases longues (purines) ============

// ------ 2 liaisons H (Adenine) ------

difference() {
    difference(){
        union(){
            cyl_block(3,0,3.1,2, height = FULL*0.8, nibbles_on_off=false);
            difference(){
                difference(){
                block(4,-1,3.1,5,4,height = FULL*0.8);
                translate([0,-8,0]) rotate ([0,0,15]) cube([70,20,30]);
            }
            translate([0,-28.5,0]) rotate ([0,0,-15]) cube([70,20,30]);
            }
        }
        union(){
            translate([63,0,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
            translate([63,-15.8,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
        }
    }
    translate ([31.6,-7.9,0]) cylinder(15,4,3);
}

// ------ 3 liaisons H (Guanine) ------
*/
difference() {
    difference(){
        union(){
            cyl_block(3,0,3.1,2, height = FULL*0.8, nibbles_on_off=false);
            difference(){
                difference(){
                block(4,-1,3.1,5,4,height = FULL*0.8);
                translate([0,-8,0]) rotate ([0,0,15]) cube([70,20,30]);
            }
            translate([0,-28.5,0]) rotate ([0,0,-15]) cube([70,20,30]);
            }
        }
        union(){
            translate([63,2,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
            translate([63,-7.9,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
            translate([63,-17.8,8.5])rotate([0,90,0])cylinder(r=2.5, h=9);
        }
    }
    translate ([31.6,-7.9,0]) cylinder(15,4,3);
}
